//
//  RVCollectionViewLayout.swift
//  Swift-revolvecollection-test
//
//  Created by wyz on 16/7/1.
//  Copyright © 2016年 ICTEHI. All rights reserved.
//

import UIKit

class RVCollectionViewLayout: UICollectionViewLayout {

    private var totalNum:Int!
    private var totlaAttributes:Array<UICollectionViewLayoutAttributes>!
    override func prepareLayout() {
        super.prepareLayout()
        totalNum = collectionView?.numberOfItemsInSection(0)
        totlaAttributes = []
        for i in 0..<totalNum{
            let indexPath = NSIndexPath(forRow: i, inSection: 0)
            totlaAttributes.append(layoutAttributesForItemAtIndexPath(indexPath)!)
        }
    }
    override func layoutAttributesForItemAtIndexPath(indexPath: NSIndexPath) -> UICollectionViewLayoutAttributes? {
        let attributes = UICollectionViewLayoutAttributes(forCellWithIndexPath: indexPath)
        attributes.size = CGSizeMake((collectionView?.bounds.size.width)!/(CGFloat(totalNum)/2)-20, (collectionView?.bounds.size.width)!/(CGFloat(totalNum)/2)-20)
        let attrL = (collectionView?.bounds.size.width)!/3-10
        let angle = M_PI*2*Double(indexPath.row)/Double(totalNum)
        let atrrx = (collectionView?.bounds.size.width)!/2-CGFloat(cos(angle))*attrL
        let atrry = (collectionView?.bounds.size.height)!/2-CGFloat(sin(angle))*attrL
        attributes.center = CGPointMake(atrrx, atrry)
        return attributes
    }
    override func layoutAttributesForElementsInRect(rect: CGRect) -> [UICollectionViewLayoutAttributes]? {
        return totlaAttributes
    }
    override func collectionViewContentSize() -> CGSize {
        return CGSizeMake((collectionView?.bounds.size.width)!, (collectionView?.bounds.size.width)!)
    }
}
